//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  DimGray
#property indicator_color2  DimGray
#property indicator_color3  DimGray
#property indicator_color4  DeepSkyBlue
#property indicator_color5  DeepSkyBlue
#property indicator_color6  PaleVioletRed
#property indicator_color7  PaleVioletRed
#property indicator_width4  3
#property indicator_width5  3
#property indicator_width6  3
#property indicator_width7  3
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT

//
//
//
//
//

extern string TimeFrame     = "Current time frame";
extern int    Length        = 35;
extern int    ChannelLength = 35;
extern int    Price         = PRICE_CLOSE;

double cum[];
double cumDa[];
double cumDb[];
double cumUa[];
double cumUb[];
double chu[];
double chd[];
int    timeFrame;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
      SetIndexBuffer(0,chu);
      SetIndexBuffer(1,chd);
      SetIndexBuffer(2,cum);
      SetIndexBuffer(3,cumUa);
      SetIndexBuffer(4,cumUb);
      SetIndexBuffer(5,cumDa);
      SetIndexBuffer(6,cumDb);
      
      timeFrame = stringToTimeFrame(TimeFrame);
      IndicatorShortName(timeFrameToString(timeFrame)+" Lsma trend - channeled");
   return(0); 
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double work[][2];
#define _trend 0
#define _slope 1

//
//
//
//
//

int start()
{
   int i,r,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         int limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   if (work[Bars-limit-1][_trend] ==  1 && work[Bars-limit-1][_slope] ==  1) CleanPoint(limit,cumUa,cumUb);
   if (work[Bars-limit-1][_trend] == -1 && work[Bars-limit-1][_slope] == -1) CleanPoint(limit,cumDa,cumDb);
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      double lsmac = 3.0*iMA(NULL,timeFrame,Length,0,MODE_LWMA,Price,y)  -2.0*iMA(NULL,timeFrame,Length,0,MODE_SMA,Price,y);
      double lsmap = 3.0*iMA(NULL,timeFrame,Length,0,MODE_LWMA,Price,y+1)-2.0*iMA(NULL,timeFrame,Length,0,MODE_SMA,Price,y+1);
   
         cum[i] = cum[i+1];
            if (lsmac > lsmap) cum[i] += 1;
            if (lsmac < lsmap) cum[i] -= 1;
         chu[i] = cum[ArrayMaximum(cum,ChannelLength,i)];
         chd[i] = cum[ArrayMinimum(cum,ChannelLength,i)];
         cumUa[i] = EMPTY_VALUE;
         cumUb[i] = EMPTY_VALUE;
         cumDa[i] = EMPTY_VALUE;
         cumDb[i] = EMPTY_VALUE;
         work[r][_trend] = work[r-1][_trend];
         work[r][_slope] = work[r-1][_slope];
            if (chu[i]>chu[i+1]) work[r][_trend] =  1;
            if (chd[i]<chd[i+1]) work[r][_trend] = -1;
            if (cum[i]>cum[i+1]) work[r][_slope] =  1;
            if (cum[i]<cum[i+1]) work[r][_slope] = -1;
            if (work[r][_trend] ==  1 && work[r][_slope] ==  1) PlotPoint(i,cumUa,cumUb,cum);
            if (work[r][_trend] == -1 && work[r][_slope] == -1) PlotPoint(i,cumDa,cumDb,cum);
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}